///////////////////////////////////////////////////////////
///////////////////Programme de Test VolRender/////////////
///////////////////Cyril Crassin Octobre 2003//////////////
///////////////////////////////////////////////////////////
#ifdef WIN32
#include <windows.h>
#endif

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <time.h>

#include "Common.h"

#include "VolRender.h"
#include "PaletteCreator.h"

#include <GL/glut.h>

#include "TGAManip.h"
bool vecteursMode=0;

//int winw = 512, winh = 512;

float tx = 0, ty = 0, tz = -6;
GLuint g_textureID = -1;
char *tex;
//vars de rendu
float maxi, hx, hy, hz;

int pause=0;

int cutBias=0;
bool cut=0;

int ttt;

tImageTGA lifoLogo;

////////////////////////////////////
///////////*********////////////////
////////////////////////////////////
#define IX(i,j,k) ( (i)+(Nx+2)*(j)+(Nx+2)*(Ny+2)*(k) )
/* external definitions (from solver.c) */

extern void dens_step ( int Nx, int Ny, int Nz, float * x, float * x0, float * u, float * v, float * w, float diff, float dt );
extern void vel_step ( int Nx, int Ny, int Nz, float * u, float * v, float * w, float * u0, float * v0, float * w0, float visc, float dt );
/* global variables */

static int Nx, Ny, Nz;
static float dt, diff, visc;
static float force, source;
static int dvel;

static float * u, * v, * w, * u_prev, * v_prev, *w_prev;
static float * dens, * dens_prev;

static int win_id;
static int win_x, win_y;
static int mouse_down[3];
static int omx=0, omy=0, omz=0, mx=0, my=0, mz=0;

float rx=0, ry=0, rz=0;
float posz, posy, posx;

////////////////////////////////////

/////////////Volrend//////////////


VolRender volrend;
FVector lPos=FVector(0,0,-0.5);
bool lmode=0;
int admireMode;
bool fluidmode=0;

PaletteCreator palcreat;
bool paletteMode=0;
IVector osPos=IVector(0,0,0);
int osSize=1024;

//FPS//
int globTime=0;

//////////////////////////////////



/////////Fractal/////////

void calcFractal(float *dens, int tx, int ty, int tz, double cst=0.00);


void SetOrthoProj() {

	// switch to projection mode
	glMatrixMode(GL_PROJECTION);
	// save previous matrix which contains the 
	//settings for the perspective projection
	glPushMatrix();
	// reset matrix
	glLoadIdentity();
	// set a 2D orthographic projection
	gluOrtho2D(0, win_x, 0, win_y);
	// invert the y axis, down is positive
	glScalef(1, -1, 1);
	// mover the origin from the bottom left corner
	// to the upper left corner
	glTranslatef(0, -win_y, 0);
	glMatrixMode(GL_MODELVIEW);
}

void ResetPerspProj() {
	glMatrixMode(GL_PROJECTION);
	glPopMatrix();
	glMatrixMode(GL_MODELVIEW);
}

void DispStrBitmap(void *font, const char *s) {
 
   if (s && strlen(s)) {
     while (*s) {
       glutBitmapCharacter(font, *s);
       s++;
     }
   }
}

void Print(const char *s, int px, int py) {
  glPushMatrix();
  
  glLoadIdentity();
  glDisable(GL_TEXTURE_2D);
  SetOrthoProj() ;

  glRasterPos2f(px, py);
  DispStrBitmap(GLUT_BITMAP_HELVETICA_18, s);
  
  ResetPerspProj();

  glEnable(GL_TEXTURE_2D);
  glPopMatrix();
  
}

////////////////////////

static void get_from_UI ( float * d, float * u, float * v )
{
	int i, j, size = (Nx+2)*(Ny+2)*(Nz+2);

	for ( i=0 ; i<size ; i++ ) {
		u[i] = v[i] = d[i] =w_prev[i]= 0.0f;
	}

	if ( !mouse_down[0] && !mouse_down[2]) return;

	i = (int)((       mx /(float)win_x)*Nx+1);
	j = (int)(((win_y-my)/(float)win_y)*Ny+1);

	if ( i<1 || i>Nx || j<1 || j>Ny ) return;


	if ( mouse_down[0] ) {
	  u[IX(i,j, Nz/2+1)] = force * (mx-omx);
	  v[IX(i,j, Nz/2+1)] = force * (omy-my);
	}

	if ( mouse_down[2] ) {
		d[IX(i,j, Nz/2+1)] = source;
	}



	omx = mx;
	omy = my;
	
	
	return;
}
static void free_data ( void )
{
	if ( u ) free ( u );
	if ( v ) free ( v );
	if ( w ) free ( w );
	if ( u_prev ) free ( u_prev );
	if ( v_prev ) free ( v_prev );
	if ( w_prev ) free ( w_prev );
	if ( dens ) free ( dens );
	if ( dens_prev ) free ( dens_prev );
}

static void clear_data ( void )
{
	int i, size=(Nx+2)*(Ny+2)*(Nz+2);

	for ( i=0 ; i<size ; i++ ) {
		u[i] = v[i] = w[i]=u_prev[i] = v_prev[i] =w_prev[i]= dens[i] = dens_prev[i] = 0.0f;
	}
}

static int allocate_data ( void )
{
	int size = (Nx+2)*(Ny+2)*(Nz+2);

	u			= (float *) malloc ( size*sizeof(float) );
	v			= (float *) malloc ( size*sizeof(float) );
	w			= (float *) malloc ( size*sizeof(float) );
	u_prev		= (float *) malloc ( size*sizeof(float) );
	v_prev		= (float *) malloc ( size*sizeof(float) );
	w_prev		= (float *) malloc ( size*sizeof(float) );

	dens		= (float *) malloc ( size*sizeof(float) );	
	dens_prev	= (float *) malloc ( size*sizeof(float) );

	if ( !u || !v || !w || !u_prev || !v_prev || !w_prev || !dens || !dens_prev ) {
		return ( 0 );
	}

	return ( 1 );
}




void dumpDriverInfo(void) {
  int i;
  printf("Vendor:   %s\n", glGetString(GL_VENDOR));
  printf("Renderer: %s\n", glGetString(GL_RENDERER));
  printf("Version:  %s\n", glGetString(GL_VERSION));
  printf("Extensions: %s\n", glGetString(GL_EXTENSIONS));


  glGetIntegerv(GL_MAX_3D_TEXTURE_SIZE, &i);
  printf("Max 3D texture size = %d\n", i);
}



// GLUT callback functions
void display(void) {	
  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
  glLoadIdentity();
  //glRasterPos2d( 0, -500);
  //glDrawPixels( imgFond->sizeX , imgFond->sizeY, GL_RGB, GL_UNSIGNED_BYTE, imgFond->data);
  
  
  /*glMatrixMode(GL_MODELVIEW);
  //glPushMatrix();
  
  glLoadIdentity();
  glTranslatef(tx, ty, tz);
  glRotatef(rx, 0.0, 1.0, 0.0);
  glRotatef(ry, 1.0, 0.0, 0.0);*/ 
  
  
  if(fluidmode && !pause){
    volrend.bindScalarField(dens, IVector(Nx+2, Ny+2, Nz+2)) ;
     volrend.computeGradient();
  }else
  ;//  volrend.updateDataTextureRegion(dens, IVector(0,0,0), IVector(tx+2,ty+2,tz+2));


  volrend.draw();
  
  glRasterPos2d(60,-130);
  glDrawPixels(lifoLogo.sizeX, lifoLogo.sizeY, GL_RGBA, GL_UNSIGNED_BYTE, lifoLogo.data );

 // glPopMatrix();
  if(paletteMode)
	palcreat.draw();


  char BuffFPS[100];

  int time=glutGet(GLUT_ELAPSED_TIME);
  /*printf("t: %d, FPS: %f\n", time-ttt, 1000.0/(time-globTime));
  globTime=time;*/

  sprintf(BuffFPS, "FPS: %1.2f", 1000.0/(time-globTime));
  globTime=time;
  Print(BuffFPS, 0,20);

  glutSwapBuffers();
  
 /*int time=glutGet(GLUT_ELAPSED_TIME);
  printf("t: %d, FPS: %f\n", time-ttt, 1000.0/(time-globTime));
  globTime=time;*/
}

void motion(int x, int y) {
	//////////cc/////////
	mx = x;
	my = y;

	if(mouse_down[1]){
		rx-=(float)(mx-omx);
		ry-=(float)(my-omy);
		omx = mx;
		omy = my;
		volrend.setRotation(rx, ry);
	}else if(lmode && mouse_down[0]){
		rx-=(float)(mx-omx);
		ry-=(float)(my-omy);
		omx = mx;
		omy = my;
		lPos.y=sin(rx/100.0);
		lPos.x=cos(rx/100.0);
		volrend.setLightPos(lPos);

	}else if(paletteMode){
		//printf("!: %d %d\n", x, y);
		palcreat.acquire((x-230), -y+270);//x/2, -y+200);
		volrend.setPalette(palcreat.getPalette());
		mx = omx;
		my = omy;
	}
}

void mouse(int button, int state, int x, int y) {

	switch(button){
	case GLUT_LEFT_BUTTON:
		omx = mx = x;
		omy = my = y;

		mouse_down[0] = !state;
	
		break;
	case GLUT_RIGHT_BUTTON:
		omx = mx = x;
		omy = my = y;

		mouse_down[2] = !state;
	
		break;

	case GLUT_MIDDLE_BUTTON:
			omx = mx = x;
			omy = my = y;

		mouse_down[1] = !state;
	
		break;
	}
		
}

void key(unsigned char key, int x, int y) {

  switch (key) {

  case 'q':
	exit(0);
	break;
  case 'c':
	cut=!cut;
	break;
  case 'b':
	  cutBias+=2;
	  break;
  case 'n':
	  cutBias-=2;
	  break;
  case 'l':
	  lmode=!lmode;
	  break;
  case 'v':
	  vecteursMode=!vecteursMode;
	  break;

  case 'z':
    volrend.setSlices(volrend.getSlices()+5);
    break;
    
  case 's':
    volrend.setSlices(volrend.getSlices()-5);
    break;
  case 'a':
    
    if(!admireMode){
      admireMode=volrend.getSlices();
      volrend.setSlices(1000);
    }else{
      volrend.setSlices(admireMode);
      admireMode=0;
    }
    break;
  case 'p':
    pause=!pause;
    break;
   
  case 'f': 
    fluidmode=!fluidmode; 
    volrend.loadRawData("result128.raw", IVector(128,128,128), 1);
    volrend.computeGradient();
    break;

  case 'x': 
    palcreat.switchComp();
    break;
  case 'w': 
    paletteMode=!paletteMode;
    break;

  case '+':
	osSize-=60;

	 volrend.loadRawDataPart( "g:/Ima3D_234c.raw", IVector(1024,1024,741), 1, IVector(osPos.x, osPos.y , osPos.z),IVector(osSize,osSize,osSize));
	 volrend.computeGradient();
	 break;
  case '-':
	  osSize+=60;

	  volrend.loadRawDataPart( "g:/Ima3D_234c.raw", IVector(1024,1024,741), 1, IVector(osPos.x, osPos.y , osPos.z),IVector(osSize,osSize,osSize));
	 volrend.computeGradient();
	break; 

  case '4':
	  osPos.x-=40;

	  volrend.loadRawDataPart( "g:/Ima3D_234c.raw", IVector(1024,1024,741), 1, IVector(osPos.x, osPos.y , osPos.z),IVector(osSize,osSize,osSize));
	 volrend.computeGradient();
	break; 
  case '6':
	  osPos.x+=40;

	  volrend.loadRawDataPart( "g:/Ima3D_234c.raw", IVector(1024,1024,741), 1, IVector(osPos.x, osPos.y , osPos.z),IVector(osSize,osSize,osSize));
	 volrend.computeGradient();
	break;
  case 'r':
	  clear_data();
	break;
 
  }

  volrend.setCut(cut);
  volrend.setCutBias(cutBias);
}


void idle(void){

	if(!pause && fluidmode){
		get_from_UI ( dens_prev, u_prev, v_prev );
		vel_step ( Nx, Ny, Nz, u, v, w, u_prev, v_prev, w_prev, visc, dt );
		dens_step ( Nx, Ny, Nz, dens, dens_prev, u, v, w, diff, dt );
	
	}

/*	static int p=-20;
	p++;

	calcFractal(dens, Nx, Ny, Nz, (double)p/20.0);
	volrend.bindScalarField(dens, IVector(Nx, Ny, Nz));

	volrend.computeGradient();*/

  glutPostRedisplay();


}

void reshape(int w, int h)
{
  win_x = w;
  win_y = h;

  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();
  gluPerspective(60.0, (float) w / (float) h, 0.0, 400.0);

  glMatrixMode(GL_MODELVIEW);
  glViewport(0, 0, w, h);

}

void initGL() {
  //glEnable(GL_DEPTH_TEST);

  glClearColor(0.0, 0.0, 0.2, 0.0);
  glEnable(GL_TEXTURE_2D);


	////////////////
	hx = 2.0f/Nx;
	hy = 2.0f/Ny;
	hz = 2.0f/Nz;



}

void initPointSprites( void ) {

	/////////
	Nx =170;
	Ny=170;
	Nz=170;
	dt = 0.40f;
	diff = 0.0f;
	visc = 0.005f;
	force = 1.0f;
	source = 100.0f;

	if ( !allocate_data () ) exit ( 1 );
	clear_data ();

	win_x = 512;
	win_y = 512;

	/////////
}

int main(int argc, char **argv) {
  glutInit(&argc, argv);

  glutInitDisplayMode(GLUT_RGBA | GLUT_DEPTH | GLUT_DOUBLE);
  glutInitWindowSize(500, 500);
  (void) glutCreateWindow("3D volume rendering, Cyril Crassin Octobre 2003");

  glutDisplayFunc(display);
  glutKeyboardFunc(key);
  //glutSpecialFunc(special);
  glutReshapeFunc(reshape);
  glutMouseFunc(mouse);
  glutMotionFunc(motion);
  glutIdleFunc(idle);
 
	

  if ( !allocate_data () ) 
	exit ( 1 );

  clear_data ();

  dumpDriverInfo();

	initPointSprites();
  initGL();

	clear_data ();
	srand(time(0));
	

	LoadTGA("lifoLogo Small.tga", &lifoLogo);
	
	
	try{
	
	  //volrend.initExts();
		volrend.init();
		
	//	volrend.loadRawData("result128.raw", IVector(128,128,128), 1);
	//	volrend.loadRawDataOriginal("Ima3D_234c.raw", IVector(128,128,128), 1);
		
		//volrend.loadRawDataPart( "g:/Ima3D_234c.raw", IVector(1024,1024,741), 1, IVector(200,500,200),IVector(256,256,256), IVector(128,128,128));
	   


		//volrend.loadRawDataPart( "g:/Ima3D_234c.raw", IVector(1024,1024,741), 1, IVector(osPos.x, osPos.y , osPos.z),IVector(osSize,osSize,osSize), IVector(128,128,128));
	     
		calcFractal(dens, Nx, Ny, Nz);
		volrend.bindScalarField(dens, IVector(Nx, Ny, Nz));

		volrend.computeGradient();


		glutMainLoop();

	}catch(VolRender::CgError &e){
#ifdef WIN32
		MessageBox(0, e.context, e.errString, 0);
#else
		printf("CG error: %s: \n\nIN:\n %s\n", e.errString , e.context);
#endif
	}catch(VolRender::Error &e){
#ifdef WIN32
		MessageBox( 0, e.errString, "Erreur VolRender", 0);
#else
		printf("VolRender error: %s:\n", e.errString);
#endif
	}
  return 0;
}
